%
% This program is free software; you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation; either version 3 of the License, or
% (at your option) any later version.
%
% Written (W) 2005-2009 Gunnar Raetsch, Gabriele Schweikert, Jonas Behr, Soeren Sonnenburg, Alexander Zien, Georg Zeller, Andre Noll, Cheng Soon Ong, Petra Philips
% Copyright (C) 2005-2009 Max Planck Society and Fraunhofer Institute FIRST 
%
function [mem_mb, time_min, opts] = rproc_memtime_policy(function_name, data_size, options, verbosity) ;
% [mem_mb, resubmit,options] = rproc_mem_policy(function_name, data_size, options) ;

if nargin<4,
  verbosity=1 ;
end ;
if nargin<3,
  options=struct ;
end ;
  
mem_mb = 2000 ;
time_min = 1000 ;

resubmit = 3 ;
opts = options ;
opts.resubmit = resubmit ;
opts.mem_req_resubmit = [5000 7000 16000] ;
opts.time_req_resubmit = [2000 3000 5000] ;
opts.data_size = data_size ;
opts.priority = 50 ;

if isequal(function_name, 'load_and_train'),

elseif isequal(function_name, 'load_and_predict'),

elseif isequal(function_name, 'concat_genomewide_predictons_helper'),

elseif isequal(function_name, 'Out2Confhelper'),

elseif isequal(function_name, 'save_label_files_starter'),

elseif isequal(function_name, 'save_examples'),

elseif length(function_name)>=length('signal_wrapper') && isequal(function_name(1:length('signal_wrapper')), 'signal_wrapper')

  if isequal(function_name, 'signal_wrapper:tss') || isequal(function_name, 'signal_wrapper:cleave')
    mem_mb = 4000 ;
    time_min = 2000 ;
    opts.resubmit = 2 ;
    opts.mem_req_resubmit = [7000 16000] ;
    opts.time_req_resubmit = [5000 8000] ;
  end ;

elseif isequal(function_name, 'gen_paths'),

  mem_mb = 500 ;
  time_min = 30 ;
  
  if abs(data_size)>100000,
    mem_mb = mem_mb*2 ;
  end ;
  
  resubmit = 2 ;
  opts = options ;
  opts.resubmit = resubmit ;
  opts.mem_req_resubmit = [mem_mb*2 mem_mb*4] ;
  opts.time_req_resubmit = [300 1000] ;
  opts.data_size = data_size ;
  
elseif isequal(function_name, 'predict'),
  
  mem_mb = 4000 ;
  time_min = 500 ;
  
  resubmit = 0 ;
  opts = options ;
  opts.resubmit = resubmit ;
  opts.mem_req_resubmit = [] ;
  opts.time_req_resubmit = [] ;
  opts.data_size = data_size ;

end ;


if verbosity>=1
  if ~isempty(data_size),
    fprintf('rproc_memtime_policy for %s with data_size=%i: %i Mb and %i minutes\n', ...
            function_name, data_size(1), mem_mb, time_min) ;
  else
    fprintf('rproc_memtime_policy for %s: %i Mb and %i minutes\n', ...
            function_name, mem_mb, time_min) ;
  end ;
end ;

